if arg[#arg] == "debug" then 
	require("lldebugger").start()
end

local HC = require 'HC'

local colliders = {}
local world 
local player
local text = ""

function love.load(args)
    for x = 3, 20, 1 do
        local width = 32
        local height = 32
        local spacing = 0
        local offset_x = 0
        local offset_y = 0
        local margin = 0
        local y = 10

        local quadX = ((x - 1) * width + margin + (x - 1) * spacing) + offset_x
        local quadY = ((y - 1) * height + margin + (y - 1) * spacing) + offset_y

        print('rect:', quadX, quadY, width, height)

        local o = {name="tile", x=quadX, y=quadY}
        o.rect = HC.rectangle(quadX, quadY, 32, 32)

        table.insert(colliders, o)
    end

    player = {name="Player", x = 100, y = 50}
    player.rect = HC.rectangle(100, 50,20, 32)
    --player.rect:rotate(45)
end

function love.update(dt)
    local x = 0
    local y = 98
    if (love.keyboard.isDown('left')) then
        x = -100
    end

    if (love.keyboard.isDown('right')) then
        x = 100
    end

    --if (player.onGround) then
    --    y = 0
    --end
    
    player.rect:move(x * dt, y * dt)

    player.onGround = false
    local cols = HC.collisions(player.rect)
    for other, separating_vector in pairs(cols) do
        local cx, cy = player.rect:center()
        cy = cy + 16
        cy = cy + (separating_vector.y * dt)

        print('cy:', cy)
        local ocx, ocy = other:center()
        local newy = (ocy - 16) - 16
        --player.rect:move(separating_vector.x, separating_vector.y)
        player.rect:moveTo(cx, newy)

        --if (separating_vector.y <= 0.0) then
        --    player.onGround = true
        --end
    end

end

function love.draw()
    local color = {love.graphics.getColor()}
    for _, c in pairs(colliders) do
        love.graphics.setColor(1, 1, 1, 1)
        love.graphics.rectangle("fill", c.x, c.y, 32, 32)
    end

   love.graphics.setColor(1, 0, 1, 1)
   player.rect:draw()
   love.graphics.setColor(color)

   love.graphics.print(text, 10, 10)
end

function love.resize(w, h)
end

function love.keypressed(k)
end

function love.textinput(t)
end


